'use strict';
var paymentType = require('../services/paymentTypeService.js');
const { body } = require('express-validator')

exports.validate = (method) => {
  switch (method) {
    case 'addPaymentType': {
     return [
        body('unit', 'Unit is required.').not().isEmpty(),
       ]
    }
  }
}

const { validationResult } = require('express-validator');

exports.addPaymentType = function(req, res){
  const errors = validationResult(req);
  if (!errors.isEmpty()){
    res.status(422).json({ errors: errors.array() });
    return;
  }
  paymentType.addPaymentType(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.listPaymentTypes = function(req, res){
  paymentType.listPaymentTypes(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.getPaymentType = function(req, res){
  paymentType.getPaymentType(req.headers.authorization,req.query.id,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.updatePaymentType = function(req, res){
  paymentType.updatePaymentType(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.deletePaymentType = function(req, res){
  paymentType.deletePaymentType(req.headers.authorization,req.query.id,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};