'use strict';
var plan = require('../services/planService.js');
const { body } = require('express-validator')

exports.validate = (method) => {
  switch (method) {
    case 'add_plan': {
     return [
        body('name', 'Name is required.').not().isEmpty(),
       ]
    }
  }
}

const { validationResult } = require('express-validator');

exports.add_plan = function(req, res){
  const errors = validationResult(req);
  if (!errors.isEmpty()){
    res.status(422).json({ errors: errors.array() });
    return;
  }
  plan.add_plan(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.plan_list = function(req, res){
  plan.plan_list(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.loadPlans = function(req, res){
  plan.loadPlans(function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.get_plan = function(req, res){
  plan.get_plan(req.headers.authorization,req.body.id,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.getUserPlans = function(req, res){
  plan.getUserPlans(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.getUserPlansLogs = function(req, res){
  plan.getUserPlansLogs(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.addUserPlan = function(req, res){
  plan.addUserPlan(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.getCurrentPlan = function(req, res){
  plan.getCurrentPlan(req.headers.authorization,req.body.id,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.getPlanHistory = function(req, res){
  plan.getPlanHistory(req.headers.authorization,req.body.id,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.selectPlan = function(req, res){
  plan.selectPlan(req.query.id,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.update_plan = function(req, res){
  plan.update_plan(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.update_user_plan = function(req, res){
  plan.update_user_plan(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};


exports.savePlanUser = function(req, res){
  plan.savePlanUser(req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.delete_plan = function(req, res){
  plan.delete_plan(req.headers.authorization,req.body.id,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.delete_user_plan = function(req, res){
  plan.delete_user_plan(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};