'use strict';
var restaurant = require('../services/restaurantService.js');
const { body } = require('express-validator')

exports.validate = (method) => {
  switch (method) {
    case 'add_restaurant': {
     return [
        body('password', 'New password is required.').not().isEmpty(),
        body('restaurant_name', 'Name is required.').not().isEmpty(),
       ]
    }
  }
}

const { validationResult } = require('express-validator');

exports.add_restaurant = function(req, res){
  const errors = validationResult(req);
  if (!errors.isEmpty()){
    res.status(422).json({ errors: errors.array() });
    return;
  }
  restaurant.add_restaurant(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.restaurant_list = function(req, res){
  restaurant.restaurant_list(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.getRestaurant = function(req, res){
  restaurant.getRestaurant(req.headers.authorization,req.body.id,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.update_restaurant = function(req, res){
  restaurant.update_restaurant(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.delete_restaurant = function(req, res){
  restaurant.delete_restaurant(req.headers.authorization,req.body.id,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.toggleRestaurantStatus = function(req, res){
  restaurant.toggleRestaurantStatus(req.headers.authorization,req.body.id,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};