'user strict';
var sql = require('./../../conf/db.js');
var logsFile = require('./logsModel.js');
var userDefinedFunction = require('../../lib/user_defined_function.js');
var jwt = require('jsonwebtoken');
var account = function(use){

};
account.addAccount = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, res) {
            if(!err){
                var createdDate = userDefinedFunction.databaseFormat();
                sql.query("SELECT * FROM accounts WHERE account_number='"+body.account_number+"' AND user_id='"+body.user_id+"' AND is_deleted='0'",function(errss,ress){
                    if(ress[0]){
                        response = {
                            'status':'Exist',
                            'message':'Account already exist',
                        }
                        resolve(response)
                    }
                    else{
                        sql.query("INSERT INTO accounts ( `user_id`,`account_number`, `name`, `account_type`, `created_at`, `updated_at`)  VALUES ('"+body.user_id+"','"+body.account_number+"','"+body.name+"','"+body.account_type+"','"+createdDate+"','"+createdDate+"')",function(errss,ress){
                            if(!errss){       
                                var logsData={added_by:body.user_id,type:'add_account',message:'Account ('+body.name+') has been added',json_data:JSON.stringify({id:ress.insertId,type:'account'})}  
                                logsFile.addLogs(authorization,logsData);
                                response = {
                                    'status':'success',
                                    'message':'Account added successfully',
                                }
                            }
                            else {                                    
                                response = {
                                    'status': 'fail',
                                    'message': 'failed to add account',
                                }                                        
                            }
                            resolve(response)
                        });
                    }
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

account.getAccount = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, res) {
            if(!err){
                sql.query("SELECT * from accounts WHERE id='"+id+"'",function(errss,ress){
                        if(ress[0]){    
                            response = {
                                'status':'success',
                                data:ress[0],
                            }
                        }
                        else {                                    
                            response = {
                                'status': 'fail',
                                'message': 'error to get Account',
                            }                                        
                        }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

account.listAccounts = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, res) {
            if(!err){                
                var search='1 AND ';
                if(body.user_id)
                    search+="user_id = '"+body.user_id+"' AND "
                if(body.account_number)
                    search+="account_number LIKE '%"+body.account_number.trim()+"%' AND "
                if(body.name)
                    search+="name LIKE '%"+body.name.trim()+"%' AND "
                if(body.account_type)
                    search+="account_type LIKE '%"+body.account_type.trim()+"%' AND "

                if(body.orderBy==undefined)
                {
                    body.orderBy=1
                    body.sort='desc';
                }

                //console.log("SELECT * from accounts WHERE "+search+" is_deleted='0' order by "+body.orderBy+" "+body.sort)

                sql.query("SELECT * from accounts WHERE "+search+" is_deleted='0' order by "+body.orderBy+" "+body.sort,function(errss,ress){
                        if(ress){    
                            response = {
                                'status':'success',
                                data:ress,
                            }
                        }
                        else {                                    
                            response = {
                                'status': 'fail',
                                'message': 'error to list accounts',
                            }                                        
                        }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

account.editAccount = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, res) {            
            var createdDate = userDefinedFunction.databaseFormat();
            if(!err){
                sql.query("SELECT * FROM accounts WHERE account_number='"+body.account_number+"' AND user_id='"+body.user_id+"' AND is_deleted='0' AND id!='"+body.id+"'",function(errss,ress){
                    if(ress[0]){
                        response = {
                            'status':'Exist',
                            'message':'Account already exist',
                        }
                        resolve(response)
                    }
                    else{
                        sql.query("UPDATE accounts SET account_number='"+body.account_number+"', name='"+body.name+"', account_type='"+body.account_type+"', updated_at='"+createdDate+"' WHERE id='"+body.id+"'",function(errs,ress){
                            if(!errs){     
                                var logsData={added_by:body.user_id,type:'update_account',message:'Account ('+body.name+') has been updated',json_data:JSON.stringify({id:body.id,type:'account'})}  
                                logsFile.addLogs(authorization,logsData);
                                response = {
                                    'status':'success',
                                    'message':'Successfully updated the account',
                                }
                            }
                            else{
                                response = {
                                    'status': 'error',
                                    'message': errs,
                                }
                            }
                            resolve(response)
                        });
                    }
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

account.deleteAccount = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, res) {
            if(!err){
                //console.log("UPDATE accounts SET is_deleted=1 WHERE id='"+id+"'")
                sql.query("UPDATE accounts SET is_deleted=1 WHERE id='"+id+"'",function(errs,ress){
                        if(!errs){    
                            sql.query("SELECT * from accounts WHERE is_deleted=1 AND id='"+id+"'",function(errss,body){
                                var logsData={added_by:body[0].user_id,type:'delete_account',message:'Account ('+body[0].name+') has been deleted',json_data:JSON.stringify({id:body[0].id,type:'account'})}  
                                logsFile.addLogs(authorization,logsData);
                            });
                            response = {
                                'status':'success',
                                'message':'Successfully deleted the account'
                            }
                        }
                        else {                                    
                            response = {
                                'status': 'fail',
                                'message': 'error to delete account',
                            }                                        
                        }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 


module.exports= account;