'user strict';
var sql = require('./../../conf/db.js');
var config = require('./../../conf/config.js');
var userDefinedFunction = require('../../lib/user_defined_function.js');
const bcrypt = require('bcrypt');
var jwt = require('jsonwebtoken');
var fileUpload = require('express-fileupload'); 
const saltRounds = 10;
var passwordHash;
var dailyReport = function(use){

};

async function  generatePassword(password){
    return new Promise((resolve) => {
        bcrypt.hash(password, saltRounds, function(err, hash) {
            resolve(hash);
        });
    });
}

//Add dailyReport function
dailyReport.addDailyReport = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){ 
                var createdDate = userDefinedFunction.databaseFormat();
                var reportDate = userDefinedFunction.formatDate(body.report_date);
                sql.query("INSERT INTO daily_report_book (`user_id`, `login_user_id`,`report_date`, `remarks`,`weather`,temperature, `gross_sales`, `total_categories_sales`, `total_staff_sales`, `difference_gross_categories_sales`, `difference_gross_staff_sales`, `is_deleted`, `created_at`, `updated_at`) VALUES ('"+body.user_id+"','"+body.login_user_id+"','"+reportDate+"','"+body.remarks+"','"+body.weather+"','"+body.temperature+"','"+body.daily_sales_gross+"','"+body.total_categories_sales+"','"+body.total_staff_sales+"','"+body.difference_gross_categories_sales+"','"+body.difference_gross_staff_sales+"','0','"+createdDate+"','"+createdDate+"')",function(errs,res){
                    sql.query("SELECT id from daily_report_book order by id desc limit 1",function(errs,last_id){
                        for(var i=0;i<body.category_fields.length;i++){
                            if(body.category_fields[i].category_sales)
                                sql.query("INSERT INTO daily_sales_categories_report (`daily_report_book_id`, `category_id`, `sales`, `is_deleted`, `created_at`, `updated_at`) VALUES ('"+last_id[0].id+"','"+body.category_fields[i].category_id+"','"+body.category_fields[i].category_sales+"','0','"+createdDate+"','"+createdDate+"')",function(errs,res){});
                        }
                        for(var i=0;i<body.staff_sale_fields.length;i++){
                            if(body.staff_sale_fields[i].staff_sales)
                                sql.query("INSERT INTO daily_sales_staff_report (`daily_report_book_id`, `waiter_id`,`total_correction`, `sales`, `is_deleted`, `created_at`, `updated_at`) VALUES ('"+last_id[0].id+"','"+body.staff_sale_fields[i].staff_id+"','"+body.staff_sale_fields[i].total_correction+"','"+body.staff_sale_fields[i].staff_sales+"','0','"+createdDate+"','"+createdDate+"')",function(errs,res){});
                        }
                    });
                    if(!errs){    
                        response = {
                            'status':'success',
                            'message':'Successfully inserted the Daily Report',
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//dailyReport list function
dailyReport.listDailyReport = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        //console.log()
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                var search='1 AND ';
                var reportDateFrom = userDefinedFunction.formatDate(body.report_date_from);
                var reportDateTo = userDefinedFunction.formatDate(body.report_date_to);
                if(!body.report_date_to && body.report_date_from)
                    search+="report_date BETWEEN '"+reportDateFrom+"' AND '"+reportDateFrom+"' AND "
                if(body.report_date_to && !body.report_date_from)
                    search+="report_date BETWEEN '"+reportDateTo+"' AND '"+reportDateTo+"' AND "
                if(body.report_date_to && body.report_date_from)
                    search+="report_date BETWEEN '"+reportDateFrom+"' AND '"+reportDateTo+"' AND "
                if(body.user_id)
                    search+="login_user_id = '"+body.user_id+"' AND "
                if(body.gross_sales)
                    search+="gross_sales LIKE '%"+body.gross_sales.trim()+"%' AND "

                if(body.orderBy==undefined)
                {
                    body.orderBy=1
                    body.sort='desc';
                }
                // if(body.orderBy=='staff_name')
                // {
                //     body.orderBy='users.full_name'
                // }
                //console.log("SELECT *,DATE_FORMAT(report_date,'%d/%m/%Y') as report_date FROM daily_report_book WHERE "+search+" is_deleted='0' order by "+body.orderBy+" "+body.sort)
                sql.query("SELECT * FROM daily_report_book WHERE "+search+" is_deleted='0' order by "+body.orderBy+" "+body.sort,function(errs,res){
                    if(!errs){   
                        response = {
                            'status':'success',
                            'message':'Successfully got all the Daily Reports',
                            data:res,
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }
            
        }); 
    });
} 

//Get dailyReport function
dailyReport.getDailyReport = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                //console.log("res")
                sql.query("SELECT *,DATE_FORMAT(report_date,'%d/%m/%Y') as report_date FROM daily_report_book WHERE id='"+id+"'",function(errs,res){
                    if(!errs){
                        if(res){    
                            sql.query("SELECT * FROM daily_sales_categories_report WHERE daily_report_book_id='"+id+"'",function(errs,resCategory){
                                if(!errs){
                                    sql.query("SELECT * FROM daily_sales_staff_report WHERE daily_report_book_id='"+id+"'",function(errs,resStaff){
                                        if(!errs){
                                            sql.query("SELECT * FROM daily_sales_staff WHERE daily_report_book_id='"+id+"'",function(errs,resSellStaff){
                                                if(!errs){
                                                    sql.query("SELECT * FROM daily_sales_staff_cash_details WHERE daily_report_book_id='"+id+"'",function(errs,resCashDetail){
                                                        if(!errs){
                                                            sql.query("SELECT * FROM daily_sales_staff_payment_method_details WHERE daily_report_book_id='"+id+"'",function(errs,resPaymentMethod){
                                                                if(!errs){
                                                                    response = {
                                                                        'status':'success',
                                                                        data:res,
                                                                        resCategory:resCategory,
                                                                        resStaff:resStaff, 
                                                                        resSellStaff:resSellStaff,
                                                                        resCashDetail:resCashDetail,
                                                                        resPaymentMethod:resPaymentMethod,

                                                                    }
                                                                    //console.log(response)
                                                                    resolve(response)
                                                                }
                                                            });
                                                        }
                                                    });
                                                }
                                            });
                                        }
                                    });
                                }
                            });                           
                        }
                        else {                                    
                            response = {
                                'status': 'fail',
                                'message': 'Daily Report Book not found',
                            }     
                            resolve(response)                                   
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                        resolve(response)
                    }
                   
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Get ReportDates function
dailyReport.getReportDates = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                //console.log("res")
                sql.query("SELECT report_date FROM daily_report_book where login_user_id="+id,function(errs,res){
                    if(!errs){
                        if(res){                                
                            response = {
                                'status':'success',
                                data:res,

                            }
                            //console.log(response)
                            resolve(response)      
                        }
                        else {                                    
                            response = {
                                'status': 'fail',
                                'message': 'Daily Report Book not found',
                            }     
                            resolve(response)                                   
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                        resolve(response)
                    }
                   
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Update dailyReport function
dailyReport.updateDailyReport = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        //console.log(body)
        jwt.verify(token, 'secret', function(err, decoded) {            
            var createdDate = userDefinedFunction.databaseFormat();
            if(!err){
                for(var i=0;i<body.category_fields.length;i++){
                    if(body.category_fields[i].category_report_id && body.category_fields[i].category_sales)
                        sql.query("UPDATE daily_sales_categories_report SET `category_id`='"+body.category_fields[i].category_id+"', `sales`='"+body.category_fields[i].category_sales+"',  `updated_at`='"+createdDate+"' WHERE id='"+body.category_fields[i].category_report_id+"'",function(errs,res){});                    
                    else if(!body.category_fields[i].category_report_id  && body.category_fields[i].category_sales)                     
                        sql.query("INSERT INTO daily_sales_categories_report (`daily_report_book_id`, `category_id`, `sales`, `is_deleted`, `created_at`, `updated_at`) VALUES ('"+body.id+"','"+body.category_fields[i].category_id+"','"+body.category_fields[i].category_sales+"','0','"+createdDate+"','"+createdDate+"')",function(errs,res){});
                    else if(!body.category_fields[i].category_sales)
                        sql.query("DELETE FROM daily_sales_categories_report WHERE id='"+body.category_fields[i].category_report_id+"'",function(errs,res){});
                }

                for(var i=0;i<body.staff_sale_fields.length;i++){
                    if(body.staff_sale_fields[i].staff_report_id && body.staff_sale_fields[i].staff_sales)
                        sql.query("UPDATE daily_sales_staff_report SET `waiter_id`='"+body.staff_sale_fields[i].staff_id+"', `sales`='"+body.staff_sale_fields[i].staff_sales+"',`total_correction`='"+body.staff_sale_fields[i].total_correction+"',`updated_at`='"+createdDate+"' WHERE id='"+body.staff_sale_fields[i].staff_report_id+"'",function(errs,res){});
                    else if(!body.staff_sale_fields[i].staff_report_id && body.staff_sale_fields[i].staff_sales) 
                        sql.query("INSERT INTO daily_sales_staff_report (`daily_report_book_id`, `waiter_id`, `sales`, `total_correction`,`is_deleted`, `created_at`, `updated_at`) VALUES ('"+body.id+"','"+body.staff_sale_fields[i].staff_id+"','"+body.staff_sale_fields[i].staff_sales+"','"+body.staff_sale_fields[i].total_correction+"','0','"+createdDate+"','"+createdDate+"')",function(errs,res){});
                    else if(!body.staff_sale_fields[i].staff_sales) 
                        sql.query("DELETE FROM daily_sales_staff_report WHERE id='"+body.staff_sale_fields[i].staff_report_id+"'",function(errs,res){});
                }
                var reportDate = userDefinedFunction.formatDate(body.report_date);
                sql.query("UPDATE daily_report_book SET `login_user_id`='"+body.login_user_id+"',`report_date`='"+reportDate+"', `remarks`='"+body.remarks+"', `weather`='"+body.weather+"', `temperature`='"+body.temperature+"', `gross_sales`='"+body.daily_sales_gross+"', `total_categories_sales`='"+body.total_categories_sales+"', `total_staff_sales`='"+body.total_staff_sales+"', `difference_gross_categories_sales`='"+body.difference_gross_categories_sales+"', `difference_gross_staff_sales`='"+body.difference_gross_staff_sales+"', `updated_at`='"+createdDate+"' WHERE id='"+body.id+"'",function(errs,res){
                    if(!errs){    
                        response = {
                            'status':'success',
                            'message':'Successfully updated the daily report book',
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Delete dailyReport function
dailyReport.deleteDailyReport = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                sql.query("UPDATE daily_report_book SET is_deleted='1' WHERE id='"+id+"'",function(errs,res){
                    if(!errs){
                        if(res){    
                            sql.query("UPDATE daily_sales_categories_report SET is_deleted='1' WHERE daily_report_book_id='"+id+"'",function(errs,resCategory){
                                if(!errs){
                                    sql.query("UPDATE daily_sales_staff_report SET is_deleted='1' WHERE daily_report_book_id='"+id+"'",function(errs,resStaff){
                                        if(!errs){
                                            sql.query("UPDATE daily_sales_staff SET is_deleted='1' WHERE daily_report_book_id='"+id+"'",function(errs,res){
                                                if(!errs){
                                                    sql.query("UPDATE daily_sales_staff_cash_details SET is_deleted='1' WHERE daily_report_book_id='"+id+"'",function(errs,resCategory){
                                                        if(!errs){
                                                            sql.query("UPDATE daily_sales_staff_payment_method_details SET is_deleted='1' WHERE daily_report_book_id='"+id+"'",function(errs,resStaff){
                                                                if(!errs){
                                                                    response = {
                                                                        'status':'success',
                                                                        'message': 'Deleted successfully',
                                                                    }
                                                                    resolve(response)
                                                                }
                                                            });
                                                        }
                                                    });
                                                }
                                            });
                                        }
                                    });
                                }
                            });                           
                        }
                        else {                                    
                            response = {
                                'status': 'fail',
                                'message': 'Daily Report Book not found',
                            }     
                            resolve(response)                                   
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

module.exports= dailyReport;