'user strict';
var sql = require('./../../conf/db.js');
var config = require('./../../conf/config.js');
var userDefinedFunction = require('../../lib/user_defined_function.js');
const bcrypt = require('bcrypt');
var jwt = require('jsonwebtoken');
var fileUpload = require('express-fileupload'); 
const saltRounds = 10;
var passwordHash;
var plan = function(use){

};

async function  generatePassword(password){
    return new Promise((resolve) => {
        bcrypt.hash(password, saltRounds, function(err, hash) {
            resolve(hash);
        });
    });
}

//Add plan function
plan.add_plan = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                var createdDate = userDefinedFunction.databaseFormat();
                sql.query("INSERT INTO plans (name,type,price,description,is_deleted,created_at,updated_at) VALUES ('"+body.name+"','"+body.type+"',"+body.price+",'"+body.description+"','0','"+createdDate+"','"+createdDate+"')",function(errs,res){
                    if(!errs){    
                        response = {
                            'status':'success',
                            'message':'Successfully inserted the plan',
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//plan list function
plan.plan_list = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        //console.log()
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                var search='1 AND ';
                if(body.name)
                    search="name LIKE '%"+body.name.trim()+"%' AND "
                if(body.type)
                    search+="type LIKE '%"+body.type.trim()+"%' AND "

                if(body.orderBy==undefined)
                {
                    body.orderBy=1
                    body.sort='desc';
                }

                sql.query("SELECT * from plans WHERE "+search+" is_deleted='0' order by "+body.orderBy+" "+body.sort,function(errs,res){
                    if(!errs){   
                        response = {
                            'status':'success',
                            'message':'Successfully got all the plans',
                            data:res,
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }
            
        }); 
    });
} 

//plan list function
plan.loadPlans = async function() {
    return new Promise((resolve) => {
        sql.query("SELECT *,CONCAT(UCASE(LEFT(type, 1)),SUBSTRING(type, 2)) as type from plans WHERE is_deleted='0'",function(errs,res){
            if(!errs){   
                response = {
                    'status':'success',
                    'message':'Successfully got all the plans',
                    data:res,
                }
            }
            else{
                response = {
                    'status': 'error',
                    'message': errs,
                }
            }
            resolve(response)
        });

    });
} 

//Get plan function
plan.get_plan = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                sql.query("SELECT * from plans WHERE id='"+id+"'",function(errs,res){
                    if(!errs){
                        if(res[0]){    
                            response = {
                                'status':'success',
                                data:res[0],
                            }
                        }
                        else {                                    
                            response = {
                                'status': 'fail',
                                'message': 'plan not found',
                            }                                        
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Get all user plans function
plan.getUserPlans = async function(authorization,body) {
    //console.log(body)
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                var created_at = userDefinedFunction.formatDate(body.start_date);
                var updated_at = userDefinedFunction.formatDate(body.expire_date);
                var search='1 AND ';
                if(body.user_id)
                    search+="user_plans.user_id = "+body.user_id+" AND "
                if(body.start_date && !body.expire_date)
                    search+="user_plans.start_date BETWEEN '"+created_at+"' AND '"+created_at+"' AND "
                if(!body.start_date && body.expire_date)
                    search+="user_plans.start_date BETWEEN '"+updated_at+"' AND '"+updated_at+"' AND "
                if(body.start_date && body.expire_date)
                    search+="user_plans.start_date BETWEEN '"+created_at+"' AND '"+updated_at+"' AND "
                if(body.plan_name)
                    search+="plans.name LIKE '%"+body.plan_name.trim()+"%' AND "
                if(body.plan_price)
                    search+="user_plans.plan_price LIKE '%"+body.plan_price.trim()+"%' AND "
                if(body.restaurant_name)
                    search+="users.full_name LIKE '%"+body.restaurant_name.trim()+"%' AND "

                if(body.orderBy=='plan_name')
                {
                    body.orderBy='plans.name'
                }
                if(body.orderBy=='plan_price')
                {
                    body.orderBy='user_plans.plan_price'
                }
                if(body.orderBy=='start_date')
                {
                    body.orderBy='user_plans.start_date'
                }
                if(body.orderBy=='expire_date')
                {
                    body.orderBy='user_plans.expire_date'
                }
                if(body.orderBy==undefined)
                {
                    body.orderBy=1
                    body.sort='desc';
                }
                console.log("SELECT DATE_FORMAT(user_plans.expire_date,'%d/%m/%Y %h:%i %p') as expire_date, DATE_FORMAT(user_plans.start_date,'%d/%m/%Y %h:%i %p') as start_date,CONCAT(UCASE(LEFT(user_plans.plan_type, 1)),SUBSTRING(user_plans.plan_type, 2)) as plan_type,user_plans.plan_price,plans.name from user_plans JOIN plans ON user_plans.plan_id=plans.id WHERE "+search+" user_plans.user_id='"+body.id+"' AND user_plans.is_deleted=0 order by "+body.orderBy+" "+body.sort+ " LIMIT 1")

                sql.query("SELECT user_plans.is_deleted, user_plans.expire_date as expire_date, (user_plans.start_date) as start_date,CONCAT(UCASE(LEFT(user_plans.plan_type, 1)),SUBSTRING(user_plans.plan_type, 2)) as plan_type,user_plans.plan_price,plans.name,users.full_name as restaurant_name from ((user_plans JOIN plans ON user_plans.plan_id=plans.id) JOIN users ON user_plans.user_id=users.id) WHERE "+search+" 1 order by "+body.orderBy+" "+body.sort,function(errs,res){
                    if(!errs){
                        if(res){    
                            response = {
                                'status':'success',
                                data:res,
                            }
                        }
                        else {                                    
                            response = {
                                'status': 'fail',
                                'message': 'user plan not found',
                            }                                        
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Get all user plans function
plan.getUserPlansLogs = async function(authorization,body) {
    //console.log(body)
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                var search='1 AND ';
                if(body.user_id)
                    search+="users.id = "+body.user_id+" AND "
                if(body.orderBy=='user_id')
                {
                    body.orderBy='users.full_name'
                }
                if(body.orderBy=='plan_id')
                {
                    body.orderBy='plans.name'
                }
                if(body.orderBy=='status')
                {
                    body.orderBy='subscription_logs.status'
                }
                if(body.orderBy=='extended_date')
                {
                    body.orderBy='subscription_logs.extended_date'
                }
                if(body.orderBy=='date')
                {
                    body.orderBy='subscription_logs.date'
                }
                if(body.orderBy==undefined)
                {
                    body.orderBy=1
                    body.sort='desc';
                }
                //console.log("SELECT DATE_FORMAT(user_plans.expire_date,'%d/%m/%Y %h:%i %p') as expire_date, DATE_FORMAT(user_plans.start_date,'%d/%m/%Y %h:%i %p') as start_date,CONCAT(UCASE(LEFT(user_plans.plan_type, 1)),SUBSTRING(user_plans.plan_type, 2)) as plan_type,user_plans.plan_price,plans.name from user_plans JOIN plans ON user_plans.plan_id=plans.id WHERE "+search+" user_plans.user_id='"+body.id+"' AND user_plans.is_deleted=0 order by "+body.orderBy+" "+body.sort+ " LIMIT 1")
                console.log("SELECT subscription_logs.*, plans.name as plan_name,users.full_name as restaurant_name from ((subscription_logs JOIN plans ON subscription_logs.plan_id=plans.id) JOIN users ON subscription_logs.user_id=users.id) WHERE "+search+" subscription_logs.is_deleted=0 order by "+body.orderBy+" "+body.sort)
                sql.query("SELECT subscription_logs.*, plans.name as plan_name,users.full_name as restaurant_name from ((subscription_logs JOIN plans ON subscription_logs.plan_id=plans.id) JOIN users ON subscription_logs.user_id=users.id) WHERE "+search+" subscription_logs.is_deleted=0 order by "+body.orderBy+" "+body.sort,function(errs,res){
                    if(!errs){
                        if(res){    
                            response = {
                                'status':'success',
                                data:res,
                            }
                        }
                        else {                                    
                            response = {
                                'status': 'fail',
                                'message': 'user plan logs not found',
                            }                                        
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Get user plan function
plan.getCurrentPlan = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){

                sql.query("SELECT user_plans.*, CONCAT(UCASE(LEFT(plans.name, 1)),SUBSTRING(plans.name, 2)) as name , CONCAT(UCASE(LEFT(plans.type, 1)),SUBSTRING(plans.type, 2)) as type from user_plans JOIN plans ON user_plans.plan_id=plans.id WHERE user_plans.user_id='"+id+"' AND user_plans.is_deleted=0 order by user_plans.expire_date desc LIMIT 1",function(errs,res){
                    if(!errs){
                        if(res[0]){    
                            response = {
                                'status':'success',
                                data:res[0],
                            }
                        }
                        else {                                    
                            response = {
                                'status': 'fail',
                                'message': 'user plan not found',
                                data:'',
                            }                                        
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Get user plan function
plan.getPlanHistory = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){

                sql.query("SELECT user_plans.*, (user_plans.expire_date) as expire_date, (user_plans.start_date) as start_date, CONCAT(UCASE(LEFT(plans.name, 1)),SUBSTRING(plans.name, 2)) as name , CONCAT(UCASE(LEFT(plans.type, 1)),SUBSTRING(plans.type, 2)) as type from user_plans JOIN plans ON user_plans.plan_id=plans.id WHERE user_plans.user_id='"+id+"' AND user_plans.is_deleted=0 order by user_plans.expire_date desc",function(errs,res){
                    if(!errs){
                        if(res[0]){    
                            response = {
                                'status':'success',
                                data:res,
                            }
                        }
                        else {                                    
                            response = {
                                'status': 'fail',
                                'message': 'user plan not found',
                                data:'',
                            }                                        
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Add user plan function
plan.addUserPlan = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                sql.query("SELECT * from plans WHERE type='"+body.type+"' AND name='"+body.name+"' AND is_deleted=0",function(errs,res){
                if(res[0]){
                    var createdDate = userDefinedFunction.databaseFormat();
                    var expiryDate = userDefinedFunction.expiryDate(body.type);

                    //console.log("INSERT INTO user_plans (user_id, plan_id, plan_price, plan_type, start_date, expire_date, status, created_at, updated_at)  VALUES ('"+body.id+"','"+res[0].id+"','"+res[0].price+"','"+res[0].type+"','"+createdDate+"','"+expiryDate+"','1','"+createdDate+"','"+createdDate+"')")

                    sql.query("INSERT INTO user_plans (user_id, plan_id, plan_price, plan_type, start_date, expire_date, status, created_at, updated_at)  VALUES ('"+body.id+"','"+res[0].id+"','"+res[0].price+"','"+res[0].type+"','"+createdDate+"','"+expiryDate+"','1','"+createdDate+"','"+createdDate+"')",function(errss,ress){ 
                            if(!errss){     
                                //console.log(ress) 
                                sql.query("SELECT * from user_plans WHERE id='"+ress.insertId+"'",function(errs,result){
                                    var extendedDate = userDefinedFunction.formatDate(result[0].start_date);
                                    //console.log("INSERT INTO `subscription_logs`( `user_id`, `plan_id`, `message`, `extended_date`,  `status`, `is_deleted`, `created_at`, `updated_at`) VALUES ('"+result[0].user_id+"','"+result[0].plan_id+"', 'Plan has been inserted.' ,'"+extendedDate+"', 'plan_inserted.' ,0,'"+createdDate+"','"+createdDate+"')");
                                    sql.query("INSERT INTO `subscription_logs`( `user_id`, `plan_id`, `message`, `extended_date`,  `status`, `is_deleted`, `created_at`, `updated_at`) VALUES ('"+result[0].user_id+"','"+result[0].plan_id+"', 'Plan has been subscribed.' ,'"+extendedDate+"', 'Subscribed' ,0,'"+createdDate+"','"+createdDate+"')",function(errs,resss){});
                                });
                                response = {
                                    'status':'success',
                                    'message':'Plan added successfully',
                                }
                            }
                            else {                                    
                                response = {
                                    'status': 'fail',
                                    'message': 'error to add',
                                }                                        
                            }
                        resolve(response)
                    });
                }
                else{
                    response = {
                        'status': 'not found',
                        'message': 'No such plan found',
                    }
                    resolve(response)
                }           
                
            });
        }
        else{
            response = {
                'status': 'TokenExpiredError',
                'message': 'Token expired',
            }
            resolve(response)
        }            
        }); 
    });
} 

//Select plan function
plan.selectPlan = async function(id) {
    return new Promise((resolve) => {        
        //console.log("SELECT * from plans WHERE id='"+id+"'")
        sql.query("SELECT * from plans WHERE id='"+id+"'",function(err,res){
            if(!err){
                if(res[0]){    
                    response = {
                        'status':'success',
                        data:res[0],
                    }
                }
                else {                                    
                    response = {
                        'status': 'fail',
                        'message': 'plan not found',
                    }                                        
                }
            }
            else{
                response = {
                    'status': 'error',
                    'message': err,
                }
            }
            resolve(response)
        });
    });
} 

//Update plan function
plan.update_plan = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {            
            var createdDate = userDefinedFunction.databaseFormat();
            if(!err){
                sql.query("UPDATE plans SET name='"+body.name+"', type='"+body.type+"', price='"+body.price+"', description='"+body.description+"',updated_at='"+createdDate+"' WHERE id='"+body.id+"'",function(errs,res){
                    if(!errs){    
                        response = {
                            'status':'success',
                            'message':'Successfully updated the plan',
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Update plan function
plan.update_user_plan = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {     
            var createdDate = userDefinedFunction.databaseFormat();
            var expireDate = userDefinedFunction.formatDate(body.expire_date);
            if(!err){
                //console.log("UPDATE user_plans SET expire_date='"+body.created_at+"' WHERE id='"+body.id+"'")
                sql.query("UPDATE user_plans SET expire_date='"+expireDate+"' WHERE id='"+body.id+"'",function(errs,res){
                    if(!errs){    
                        sql.query("SELECT * from user_plans WHERE id='"+body.id+"'",function(errs,result){
                            sql.query("INSERT INTO `subscription_logs`( `user_id`, `plan_id`, `message`, `extended_date`,  `status`, `is_deleted`, `created_at`, `updated_at`) VALUES ('"+result[0].user_id+"','"+result[0].plan_id+"', 'Plan has been extended.' ,'"+expireDate+"', 'Extended' ,0,'"+createdDate+"','"+createdDate+"')",function(errs,resss){});
                        });
                        response = {
                            'status':'success',
                            'message':'Successfully updated the plan',
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Save plan and user function
plan.savePlanUser = async function(body) {
    const passwordHash = await generatePassword(body.password);
    const validateString = await generatePassword(body.email);
    return new Promise((resolve) => {
        var createdDate = userDefinedFunction.databaseFormat();
        var verifyLink  = body.host+'/verify-email/'+validateString;
        verifyURL       = '<a href="'+verifyLink+'">Click Here</a>';
        //var fullName = body.name;
        var fullName = body.name;
        var email = body.email;
        sql.query("INSERT INTO users (user_role_id,full_name,email,password,validate_string,is_active,is_verified,created_at,updated_at) VALUES('"+config.restaurant_role_id+"','"+fullName+"','"+email+"','"+passwordHash+"','"+validateString+"','1','0','"+createdDate+"','"+createdDate+"')",function(err,res){
            if(!err){
                sql.query("SELECT id FROM users ORDER BY id DESC LIMIT 1",function(err,res){
                    repArray = [fullName,verifyURL,verifyLink];
                    userDefinedFunction.sendMail(email,repArray,'account_verification');
                    var expiryDate = userDefinedFunction.expiryDate(body.type);
                    sql.query("INSERT INTO user_plans (user_id, plan_id, plan_price, plan_type, start_date, expire_date, status, created_at, updated_at)  VALUES ('"+res[0].id+"','"+body.id+"','"+body.price+"','"+body.type+"','"+createdDate+"','"+expiryDate+"','1','"+createdDate+"','"+createdDate+"')",function(errs,ress){
                        if(!errs){    
                            response = {
                                'status':'success',
                                'message':'Account varification link successfully send to your email. Please check.',
                            }
                        }
                        else{
                            response = {
                                'status': 'errors',
                                'message': errs,
                                'message':'Failed to select plan'
                            }
                        }
                        resolve(response)
                    });
                });
            }
            else{
                response = {
                    'status': 'error',
                    'message': err,
                }
                resolve(response)
            }
        });
    });
} 

//Delete plan function
plan.delete_plan = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            var today = new Date();
            var datetime = today.getFullYear()+'-'+(today.getMonth()+1)+'-'+today.getDate()+' '+today.getHours() + ":" + today.getMinutes() + ":" + today.getSeconds();
            if(!err){
                sql.query("UPDATE plans SET is_deleted='1' WHERE id='"+id+"'",function(errs,res){
                    if(!errs){    
                        response = {
                            'status':'success',
                            'message':'Successfully deleted the plan',
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Delete user plan function
plan.delete_user_plan = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                var createdDate = userDefinedFunction.databaseFormat();
                sql.query("UPDATE user_plans SET is_deleted='1' WHERE id='"+body.id+"'",function(errs,res){
                    if(!errs){                            
                        sql.query("SELECT * from user_plans WHERE id='"+body.id+"'",function(errs,ress){
                            var extendedDate = userDefinedFunction.formatDate(ress[0].start_date);
                            sql.query("INSERT INTO `subscription_logs`( `user_id`, `plan_id`, `message`, `extended_date`,  `status`,`cancelled_by`, `is_deleted`, `created_at`, `updated_at`) VALUES ('"+ress[0].user_id+"','"+ress[0].plan_id+"', 'Plan has been unsubscribed.' ,'"+extendedDate+"', 'Cancelled' ,'"+body.logged_user_id+"' ,0,'"+createdDate+"','"+createdDate+"')",function(errs,resss){});
                        });
                        response = {
                            'status':'success',
                            'message':'Successfully deleted the plan',
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

module.exports= plan;